package com.emsoft.data.hibernate.types

import java.sql.PreparedStatement
import java.sql.ResultSet
import org.hibernate.usertype.UserType

class SqlVariant implements UserType {

    private def sqlType = java.sql.Types.JAVA_OBJECT
    private int[] sqlVariantTypes = [sqlType]

    @Override
    int[] sqlTypes() {
        return sqlVariantTypes
    }

    @Override
    Class returnedClass() {
        return Object
    }

    @Override
    boolean equals(def x, def y) {
        return x == y
    }

    @Override
    int hashCode(def x) {
        return x.hashCode()
    }

    @Override
    def nullSafeGet(ResultSet rs, String[] names, def owner) {
        def val = rs.getObject(names[0])
        if (rs.wasNull())
            return null
        return val
    }

    @Override
    void nullSafeSet(PreparedStatement st, def value, int index) {
        if (value == null) {
            st.setNull(index, sqlType)
        }
        else {
            st.setObject(index, value)
        }
    }

    @Override
    def deepCopy(def value) {
        return value
    }

    @Override
    boolean isMutable() {
        return false
    }

    @Override
    Serializable disassemble(def value) {
        return value as Serializable
    }

    @Override
    def assemble(Serializable cached, def owner) {
        return cached
    }

    @Override
    def replace(def original, def target, def owner) {
        return original
    }
}